//Author Antonio-Gabriel Sturzu

#include<stdio.h>
#include<omp.h>
#define lim 100001


int main()
{
	int m[1000][1000],n,i,j,k,chunk=1;
	double start,stop;
	FILE *f=fopen("royfloyd.in","r");

	fscanf(f,"%i",&n);
	for(i=0;i<n;i++)
		for(j=0;j<n;j++)
		{
			fscanf(f,"%i",&m[i][j]);
			if(i!=j && m[i][j]==0)
				m[i][j]=lim;
		}
	fclose(f);

	start=omp_get_wtime();
	for(k=0;k<n;k++)
	{
		#pragma omp parallel shared(m,k) private(i,j)
		{
			#pragma omp for schedule(static)
			for(i=0;i<n;i++)
				for(j=0;j<n;j++)
					if(m[i][k]+m[k][j]<m[i][j])
						m[i][j]=m[i][k]+m[k][j];
		}
	}
	stop=omp_get_wtime();
	printf("Au trecut %f secunde\n",stop-start);
	f=fopen("royfloyd.out","w");
	for(i=0;i<n;i++)
	{
		for(j=0;j<n-1;j++)
		{
			if(m[i][j]==lim)
				m[i][j]=0;
			fprintf(f,"%i ",m[i][j]);
		}
		if(m[i][n-1]==lim)
			m[i][n-1]=0;
		fprintf(f,"%i\n",m[i][n-1]);
	}
	fclose(f);
	return 0;
}
